
// BeauGauge MFC Circular ExampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "BeauGauge MFC Circular Example.h"
#include "BeauGauge MFC Circular ExampleDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CBeauGaugeMFCCircularExampleDlg dialog




CBeauGaugeMFCCircularExampleDlg::CBeauGaugeMFCCircularExampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBeauGaugeMFCCircularExampleDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CBeauGaugeMFCCircularExampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_STATIC_WEB, m_linkWeb);
	DDX_Control(pDX, IDC_STATIC_SUPPORT, m_linkSupport);
	DDX_Control(pDX, IDC_BGV2ACTIVEXCTRL1, m_gauge1);
	DDX_Control(pDX, IDC_BGV2ACTIVEXCTRL2, m_gauge2);
	DDX_Control(pDX, IDC_BGV2ACTIVEXCTRL3, m_gauge3);
	DDX_Control(pDX, IDC_BGV2ACTIVEXCTRL4, m_gauge4);
	DDX_Control(pDX, IDC_BGV2ACTIVEXCTRL5, m_gauge5);
	DDX_Control(pDX, IDC_BGV2ACTIVEXCTRL6, m_gauge6);
	DDX_Control(pDX, IDC_BGV2ACTIVEXCTRL7, m_gauge7);
	DDX_Control(pDX, IDC_BGV2ACTIVEXCTRL8, m_gauge8);
	DDX_Control(pDX, IDC_BGV2ACTIVEXCTRL9, m_gauge9);
	DDX_Control(pDX, IDC_BGV2ACTIVEXCTRL10, m_gauge10);
	DDX_Control(pDX, IDC_BGV2ACTIVEXCTRL11, m_gauge11);
}

BEGIN_MESSAGE_MAP(CBeauGaugeMFCCircularExampleDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_DESTROY()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// CBeauGaugeMFCCircularExampleDlg message handlers

BOOL CBeauGaugeMFCCircularExampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	m_linkWeb.SetURL(_T("http://www.beaugauge.com"),_T("www.beaugauge.com"));
	m_linkSupport.SetURL(_T("mailto:beaugauge@gmail.com"),_T("beaugauge@gmail.com"));

	m_random[0].SetAtom(0.4f);
	m_random[0].SetMinMax(0,100);

	m_random[1].SetAtom(0.1f);
	m_random[1].SetMinMax(0,100);

	m_random[2].SetAtom(0.6f);
	m_random[2].SetMinMax(0,100);

	m_random[3].SetAtom(0.2f);
	m_random[3].SetMinMax(0,30);

	this->SetTimer(1,1,NULL);
	this->SetTimer(2,1000,NULL);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CBeauGaugeMFCCircularExampleDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CBeauGaugeMFCCircularExampleDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CBeauGaugeMFCCircularExampleDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CBeauGaugeMFCCircularExampleDlg::OnDestroy() 
{
	this->KillTimer(1);
	this->KillTimer(2);

	CDialog::OnDestroy();	
}

void CBeauGaugeMFCCircularExampleDlg::OnTimer(UINT nIDEvent) 
{
	if(1 == nIDEvent)
	{
		double f1 = m_random[0].GetSingle();
		double f2 = m_random[1].GetSingle();
		double f3 = m_random[2].GetSingle();
		double f4 = m_random[3].GetSingle();
		m_gauge1.SetValue(_T("Needle1"),f1);
		m_gauge2.SetValue(_T("Needle1"),f3);
		m_gauge2.SetValue(_T("Needle2"),f2);
		m_gauge3.SetValue(_T("Needle1"),f2);
		m_gauge4.SetValue(_T("Needle1"),f1);
		m_gauge5.SetValue(_T("Needle1"),f2);
		m_gauge6.SetValue(_T("Needle1"),f3);
		m_gauge7.SetValue(_T("Needle1"),f4);
		m_gauge7.SetValue(_T("Needle2"),f1);
		m_gauge8.SetValue(_T("Needle1"),f1);
		m_gauge9.SetValue(_T("Needle1"),f2);
		m_gauge10.SetValue(_T("Needle1"),f1);
		m_gauge11.SetValue(_T("Needle1"),f3);
		m_gauge11.SetValue(_T("NumericIndicator1"),f3);
	}

	if(2 == nIDEvent)
	{
	}
	
	CDialog::OnTimer(nIDEvent);
}


